' *************************************************************
'             EZGUI Dialog Designer 2.0 Lite Library
'              see web site at http://ezgui.com
' Copyright (C) 2002, Christopher R. Boss , All Rights Reserved !
'
' This code is for use with the "EZGUI Dialog Designer 2.0 Lite"
' and may be used ROYALTY FREE with any application created
' using the EZGUI Dialog Designer 2.0 Lite by a Registered user.
' This Copyright notice must be kept with this source code.
'      This source code may be distributed with any application
' source code that makes use of it, but this source code may not be
' distributed by itself alone or as a standalone Library. Also it
' may not distributed as part of a Visual Designer source code library,
' designed by the user (a competing product with the EZGUI Designer).
'      You may make modifications to this code, but please add
' remarks indicating what changes have been made or simply REM
' out the old code (leave it in) and then add your own code.
'      Excerpts of this code may be posted on an online forum
' for discussion of how to improve it.
' *************************************************************


' *************************************************************
'              EZGUI Library Constants and Declares
' *************************************************************

'  --------------------------------
' Manditory Declares
'  --------------------------------
DECLARE SUB EZLIB_InitColors()
DECLARE SUB EZLIB_DeleteColors()
DECLARE FUNCTION EZLIB_Color (BYVAL FG&, BYVAL BG&, BYVAL lParam&) AS LONG
DECLARE SUB EZLIB_InitFonts()
DECLARE SUB EZLIB_DeleteFonts()
DECLARE FUNCTION EZLIB_AddX(BYVAL Style&, BYVAL HasMenu&) AS LONG
DECLARE FUNCTION EZLIB_AddY(BYVAL Style&, BYVAL HasMenu&) AS LONG
'  --------------------------------

' ===============================================
#IF %UseColorLib
    DECLARE FUNCTION EZLIB_GetColor (BYVAL N&) AS LONG
    DECLARE FUNCTION EZLIB_GetBrush (BYVAL N&) AS LONG
#ENDIF
' ===============================================

DECLARE SUB EZLIB_SetFont (BYVAL hDlg AS LONG, BYVAL ID&, BYVAL TFace$, BYVAL PSize&, BYVAL FProp$)
DECLARE SUB EZLIB_InitFonts()
DECLARE SUB EZLIB_DeleteFonts()
' ===============================================
#IF %UseFontLib
    DECLARE FUNCTION EZLIB_CreateFont (BYVAL TFace$, BYVAL PSize&, BYVAL FProp$, BYVAL hDC AS LONG) AS LONG
#ENDIF
' ===============================================

' ===============================================

' *************************************************************
'            Application Global Variables and Types
' *************************************************************

GLOBAL App_Instance&
GLOBAL App_CurrentDlg AS LONG


' ===============================================
#IF %UseColorLib
    GLOBAL App_Brush&()
    GLOBAL App_Color&()
#ENDIF
' ===============================================

' ===============================================
#IF %UseFontLib
    GLOBAL App_hFont() AS LONG
    GLOBAL App_FontName() AS STRING
#ENDIF
' ===============================================

' ----------------------------------------------------------------------

SUB EZLIB_InitColors()
' ===============================================
#IF %UseColorLib
    ' 16 DOS Compatible Colors plus 16 Pastel versions of the same
    DATA         0,  8388608,    32768,  8421376,      196,  8388736,    16512, 12895428
    DATA   8421504, 16711680,    65280, 16776960,      255, 16711935,    65535, 16777215
    DATA  10790052, 16752768, 10551200, 16777120, 10526975, 16752895, 10551295, 13948116
    DATA  11842740, 16768188, 14483420, 16777180, 14474495, 16768255, 14483455, 15000804
    LOCAL T&, RGBVal&
    ' brushes with ID's less than 0 are for 3D pattern brushes
    REDIM App_Brush&(-57 TO 31)
    REDIM App_Color&(-57 TO 31)
    FOR T&=0 TO 31
        RGBVal&=VAL(READ$(T&+1))
        App_Color&(T&)=RGBVal&
    NEXT T&
#ENDIF
' ===============================================
END SUB

' ----------------------------------------------------------------------

SUB EZLIB_DeleteColors()
' ===============================================
#IF %UseColorLib
    LOCAL T&
    FOR T&=LBOUND(App_Brush) TO UBOUND(App_Brush)
        IF App_Brush(T&)<>0 THEN DeleteObject App_Brush&(T&)
    NEXT T&
#ENDIF
' ===============================================
END SUB

' ----------------------------------------------------------------------

FUNCTION EZLIB_Color (BYVAL FG&, BYVAL BG&, BYVAL wParam&) AS LONG
' ===============================================
#IF %UseColorLib
    SELECT CASE BG&
        CASE -1             ' default colors
            FUNCTION=0
            EXIT FUNCTION
        CASE -999           ' Invisible Background
            SetTextColor wParam&, EZLIB_GetColor(FG&)
            SetBkMode wParam&, %TRANSPARENT
            SetBkColor wParam&, 0
            FUNCTION=GetStockObject(%NULL_BRUSH)
            EXIT FUNCTION
        CASE >-1            ' EZGUI BG colors
            SetTextColor wParam&, EZLIB_GetColor(FG&)
            SetBkMode wParam&, %OPAQUE
            SetBkColor wParam&, EZLIB_GetColor(BG&)
            FUNCTION=EZLIB_GetBrush(BG&)
            EXIT FUNCTION
        CASE <-1            ' EZGUI BG patterns
            SetTextColor wParam&, EZLIB_GetColor(FG&)
            SetBkMode wParam&, %TRANSPARENT
            SetBkColor wParam&, 0
            FUNCTION=EZLIB_GetBrush(BG&)
            EXIT FUNCTION
        CASE ELSE
    END SELECT
    FUNCTION=0
#ELSE
    FUNCTION=0
#ENDIF
' ===============================================
END FUNCTION

' ----------------------------------------------------------------------

' ===============================================
#IF %UseColorLib

    FUNCTION EZLIB_GetColor (BYVAL N&) AS LONG
    IF N&>=0 AND N&<=UBOUND(App_Color) THEN
        FUNCTION=App_Color(N&)
    ELSE
        FUNCTION=0
    END IF
    END FUNCTION

    ' ----------------------------------------------------------------------

    FUNCTION EZLIB_GetBrush (BYVAL N&) AS LONG
    IF N&>=LBOUND(App_Brush) AND N&<=UBOUND(App_Brush) THEN
        IF App_Brush(N&)<>0 THEN
            FUNCTION=App_Brush(N&)
            EXIT FUNCTION
        ELSE
            ' create brush now
            IF N&<-1 THEN   ' this is a pattern background
                App_Brush&(N&)=CreateSolidBrush(App_Color(N&))
                FUNCTION=App_Brush(N&)
                EXIT FUNCTION
            END IF
            IF N&>-1 THEN
                App_Brush&(N&)=CreateSolidBrush(App_Color(N&))
                FUNCTION=App_Brush(N&)
                EXIT FUNCTION
            END IF
        END IF
    END IF
    FUNCTION=0
    END FUNCTION

#ENDIF
' ===============================================


SUB EZLIB_SetFont (BYVAL hDlg AS LONG, BYVAL ID&, BYVAL TFace$, BYVAL PSize&, BYVAL FProp$)
' ===============================================
#IF %UseFontLib
    LOCAL hCtrl AS LONG, hFont AS LONG, N&, F$
    hCtrl=GetDlgItem(hDlg, ID&)
    IF hCtrl<>0 THEN
        F$=TFace$+STR$(PSize&)+FProp$
        ARRAY SCAN App_FontName() , = F$ , TO N&
        IF N&=0 THEN
            hFont=EZLIB_CreateFont(TFace$, PSize&, FProp$, 0)
            ARRAY SCAN App_FontName(), = "" , TO N&
            IF N&>0 THEN
                App_FontName(N&)=F$
                App_hFont(N&)=hFont
            END IF
        ELSE
            hFont=App_hFont(N&)
        END IF
        IF hFont<>0 THEN SendMessage hCtrl, %WM_SETFONT, hFont, %TRUE
    END IF
#ENDIF
' ===============================================
END SUB

SUB EZLIB_InitFonts()
' ===============================================
#IF %UseFontLib
    REDIM App_hFont(1 TO 100) AS LONG
    REDIM App_FontName(1 TO 100) AS STRING
#ENDIF
' ===============================================

END SUB


SUB EZLIB_DeleteFonts()
' ===============================================
#IF %UseFontLib
    LOCAL N&
    FOR N&=LBOUND(App_hFont) TO UBOUND(App_hFont)
        IF App_hFont(N&)<>0 THEN DeleteObject App_hFont(N&)
    NEXT N&
#ENDIF
' ===============================================

END SUB



' ===============================================
#IF %UseFontLib
    FUNCTION EZLIB_CreateFont (BYVAL TFace$, BYVAL PSize&, BYVAL FProp$, BYVAL hDC AS LONG) AS LONG
        LOCAL W&, E&, O&, FW&, I&, U&, ST&, CS&, PR&, CL&, Q&, PF&, FF&
        LOCAL zTemp AS ASCIIZ*80, OKFlag&, PT!, PixelSY&
        IF hDC=0 THEN
            hDC = GetDC(%HWND_DESKTOP)
            PixelSY&=GetDeviceCaps(hDC, %LOGPIXELSY)
            ReleaseDC %HWND_DESKTOP, hDC
        ELSE
            PixelSY&=GetDeviceCaps(hDC, %LOGPIXELSY)
        END IF
        PSize&=-MulDiv(PSize&, PixelSY&, 72)
        W&=0
        E&=0
        O&=0
        FW&=%FW_NORMAL
        I&=0
        U&=0
        ST&=0
        CS&=%ANSI_CHARSET
        PR&=%OUT_DEFAULT_PRECIS
        CL&=%CLIP_DEFAULT_PRECIS
        Q&=%DRAFT_QUALITY
        PF&=%DEFAULT_PITCH
        IF INSTR(FProp$,"B") THEN FW&=%FW_BOLD
        IF INSTR(FProp$,"X") THEN FW&=%FW_HEAVY
        IF INSTR(FProp$,"I") THEN I&=1
        IF INSTR(FProp$,"U") THEN U&=1
        IF INSTR(FProp$,"-") THEN ST&=1
        IF INSTR(FProp$,"D") THEN CS&=%DEFAULT_CHARSET
        IF INSTR(FProp$,"S") THEN CS&=%SYMBOL_CHARSET
        IF INSTR(FProp$,"O") THEN CS&=%OEM_CHARSET
        IF INSTR(FProp$,"Q") THEN Q&=%PROOF_QUALITY
        IF INSTR(FProp$,"F") THEN PF&=%FIXED_PITCH
        IF INSTR(FProp$,"V") THEN PF&=%VARIABLE_PITCH
        FF&=%FF_DONTCARE
        PF&=PF& OR FF&
        IF LEN(TFace$)>31 THEN TFace$=LEFT$(TFace$,31)
        zTemp=TFace$+CHR$(0)
        FUNCTION=CreateFont(PSize&,W&, E&, O&, FW&, I&, U&, ST&, CS&, PR&, CL&, Q&, PF&, zTemp)
    END FUNCTION
#ENDIF
' ===============================================

FUNCTION EZLIB_PixelToDlgUnit(BYVAL N&, BYVAL Mode&) AS LONG
    LOCAL hDC AS LONG, PPC!, PPI!, DU!, NN!
    NN!=N&
    hDC = GetDC(%HWND_DESKTOP)
    PPI!=GetDeviceCaps(hDC, %LOGPIXELSY)
    ReleaseDC %HWND_DESKTOP, hDC
    IF Mode&=0 THEN ' is vertical
        PPC!=(PPI!/96)*13
        DU!=PPC!/8
        N&=CEIL(NN!/DU!)
    ELSE
        PPC!=(PPI!/96)*6
        DU!=PPC!/4
        N&=CEIL(NN!/DU!)
    END IF
    FUNCTION=N&
END FUNCTION

FUNCTION EZLIB_AddX(BYVAL Style&, BYVAL HasMenu&) AS LONG
    LOCAL X&, Y&
    IF (Style& AND %WS_VSCROLL) = %WS_VSCROLL THEN
        X&=X&+GetSystemMetrics(%SM_CYVSCROLL)
    END IF
    FUNCTION=EZLIB_PixelToDlgUnit(X&,1)
END FUNCTION

FUNCTION EZLIB_AddY(BYVAL Style&, BYVAL HasMenu&) AS LONG
    LOCAL X&, Y&
    IF (Style& AND %WS_CAPTION) = %WS_CAPTION THEN
        IF HasMenu& THEN
            Y&=Y&+GetSystemMetrics(%SM_CYCAPTION)
        END IF
    END IF
    IF (Style& AND %WS_HSCROLL) = %WS_HSCROLL THEN
        Y&=Y&+GetSystemMetrics(%SM_CYHSCROLL)
    END IF
    FUNCTION=EZLIB_PixelToDlgUnit(Y&,0)
END FUNCTION

FUNCTION EZLIB_NotifyID(BYVAL lParam AS LONG) AS LONG
    LOCAL pNM AS NMHDR PTR
    pNM=lParam
    FUNCTION=@pNM.idfrom
END FUNCTION

' *************************************************************
'                End of EZGUI Dialogs Library
' *************************************************************
